Kerbal Space Program - Bug #2726

Right mouse button not working properly when using Steam in-home streaming.
07/05/2014 04:13 PM - sal_vager
Description

The issue.

The right mouse button is not detected in the map screen, flight scene or editor when using Steams In-home streaming software, this
prevents the use of manoeuvre nodes and the player cannot use the mouse to pan the view.

Reproduction
Setup KSP with Steams in-home streaming, try to pan the view in the flight scene while controlling from the second PC.
Implications

Although this may be considered an edge case and potentially not a KSP bug, this reveals there are differences between the KSC
screen and other areas of the game when handling mouse input.

With KSP's popularity on Steam this issue will affect a fair proportion of the Steam userbase, so it's worth seeing if it can be fixed.

For more information please see here
http://forum.kerbalspaceprogram.com/threads/84157-Steam-In-Home-Streaming-Can-t-control-camera-with-mouse

Thanks go to Glyph, ChristopherSims, anomaly256 and keyboard cat for finding this one.

History

#1 - 09/05/2014 10:56 AM - Ted
- Target version deleted (0.23.5)

#2 - 10/05/2014 11:33 AM - youen

| have the same issue when playing with VNC (more specifically, Ultra VNC, to control the game on my TV from a laptop). It's probably the way
mouse buttons are injected to the system from remote control versus physical mouse. A wild guess : two different APIs are used to access mouse
buttons state in different parts of the game, and only one works correctly with remote control.

#3 - 10/15/2014 10:10 AM - HarvesteR
- Status changed from New to Unity Bug

You are correct about the multiple APIs. Unity provides several ways to detect input, and the Ul packages we use also implement their own. It seems
a few of those are failing.

Camera controls IIRC, all use the (very standard) Input.GetMouseButton methods and Input.mousePosition to handle mouse input. This is also used
in part RMB menus, Internal View, pretty much anything that isn't a Ul panel.

Ul panels can use the methods above as well, but in several cases also use the Event class which is used in Unity's GUI loop, or in case of ezgui
panels, we use their own input logic, which | believe under the hood just picks up Unity's standard inputs as well.

My point here is, there isn't much to be done from our end to address this. It's a problem with how the Unity players receives input from the OS and
how Steam's streaming could be stealing input focus.

I have to call this one a Unity bug I'm afraid. There's really very little we can do here.
http://forum.kerbalspaceprogram.com/threads/84157-Steam-In-Home-Streaming-Can-t-control-camera-with-mouse

#4 - 10/15/2014 10:24 AM - sal_vager

| understand this Felipe, what really needs to be done to fix this is for Valve to fix IHS so it can correctly detect mouse input in KSP.

A member of Valve, Sam Lantinga, has tried to contact the Squad developers in order to find out what KSP is doing in these cases so they can fix
their program, Rowsdower knows more about that and has had contact with this gentleman, if it's not too much to ask could you discuss this issue
with him so they can fix it?

| have Sam's email, if you contact me via PM | can pass it on to you.

#5 - 01/17/2015 07:10 PM - Teralink

Any news on this issue?

#6 - 10/08/2015 10:23 PM - sal_vager
- Status changed from Unity Bug to Resolved
- % Done changed from 0 to 100

Yes actually, a #KSPOfficial member named DFrostedWang tested Steams in-house streaming today (8th October, 2015) and reports that it works
with no issues.

So this but report can be closed, bug fixed on Valves end.
IRC text

<sal_vager> odd question, does anyone here use steam inhouse streaming with ksp ?

<DFrostedWang> yea, | use steam but haven't actually tested it with KSP

<DFrostedWang> sal_vager: It should work perfectly though, assuming a wired connection or a very good wireless connection
<DFrostedWang> I've used in-home streaming before and it works perfectly for me, but all of my stuff is wired
<sal_vager> dfrosted, there is a bug in ihs, it breaks unity mouse events, i wondered if anyone could confirm it still existed
<DFrostedWang> | suppose | can

<DFrostedWang> hang about while | get my laptop out

<sal_vager> you may find that the play button for ksp is missing, a guy on the forum is complaining about that
<DFrostedWang> sal_vager: Okay, launching KSP

<sal_vager> thank you DFrostedWang

<DFrostedWang> sal_vager: So what exactly is broken?

<DFrostedWang> clicking stuff?

<sal_vager> the right mouse button was broken, so rotating the view didn't work

<DFrostedWang> sal_vager: Working fine for me

<sal_vager> hmm thats good and interesting

<DFrostedWang> sal_vager: | loaded it up and went into the VAB and moved the camera a bit, and camera movement in the overview works fine as
well

<DFrostedWang> didn't test actually with a ship, but | assume it's the same everywhere?

<sal_vager> DFrostedWang, what about in the flight scene and the map ?

<DFrostedWang> sal_vager: Yup, everything works

<sal_vager> great, thank you for helping DFrostedWang

#7 - 07/17/2016 09:18 AM - TriggerAu

- Status changed from Resolved to Closed
